LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;

ENTITY reg_pwm_state IS
PORT (
	i		: IN  std_logic_vector(7 downto 0);
	load	: IN  std_logic;
	
	state	: BUFFER std_logic_vector(7 downto 0) := "00000000";
	state_0	: OUT std_logic := '0';

	o_00	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_01	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_02	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_03	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_04	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_05	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_06	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_07	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_08	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_09	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_10	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_11	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_12	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_13	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_14	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_15	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_16	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_17	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_18	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_19	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_20	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_21	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_22	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_23	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_24	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_25	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_26	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_27	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_28	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_29	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_30	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_31	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_32	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_33	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_34	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_35	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_36	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_37	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_38	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_39	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_40	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_41	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_42	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_43	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_44	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_45	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_46	: OUT std_logic_vector(9 downto 0) ; --:= "1000000000";
	o_47	: OUT std_logic_vector(9 downto 0) --:= "1000000000"

	);
END reg_pwm_state;

ARCHITECTURE a_reg_pwm_state OF reg_pwm_state IS

BEGIN
	PROCESS 
	BEGIN
		WAIT UNTIL load'EVENT AND load = '1';
		CASE state IS
			WHEN "00000000" =>
				o_00(7 downto 0) <= i;
			WHEN "00000001" =>
				o_00(9 downto 8) <= i(1 downto 0);
			WHEN "00000010" =>
				o_01(7 downto 0) <= i;
			WHEN "00000011" =>
				o_01(9 downto 8) <= i(1 downto 0);
			WHEN "00000100" =>
				o_02(7 downto 0) <= i;
			WHEN "00000101" =>
				o_02(9 downto 8) <= i(1 downto 0);
			WHEN "00000110" =>
				o_03(7 downto 0) <= i;
			WHEN "00000111" =>
				o_03(9 downto 8) <= i(1 downto 0);
			WHEN "00001000" =>
				o_04(7 downto 0) <= i;
			WHEN "00001001" =>
				o_04(9 downto 8) <= i(1 downto 0);
			WHEN "00001010" =>
				o_05(7 downto 0) <= i;
			WHEN "00001011" =>
				o_05(9 downto 8) <= i(1 downto 0);
			WHEN "00001100" =>
				o_06(7 downto 0) <= i;
			WHEN "00001101" =>
				o_06(9 downto 8) <= i(1 downto 0);
			WHEN "00001110" =>
				o_07(7 downto 0) <= i;
			WHEN "00001111" =>
				o_07(9 downto 8) <= i(1 downto 0);
			WHEN "00010000" =>
				o_08(7 downto 0) <= i;
			WHEN "00010001" =>
				o_08(9 downto 8) <= i(1 downto 0);
			WHEN "00010010" =>
				o_09(7 downto 0) <= i;
			WHEN "00010011" =>
				o_09(9 downto 8) <= i(1 downto 0);
			WHEN "00010100" =>
				o_10(7 downto 0) <= i;
			WHEN "00010101" =>
				o_10(9 downto 8) <= i(1 downto 0);
			WHEN "00010110" =>
				o_11(7 downto 0) <= i;
			WHEN "00010111" =>
				o_11(9 downto 8) <= i(1 downto 0);
			WHEN "00011000" =>
				o_12(7 downto 0) <= i;
			WHEN "00011001" =>
				o_12(9 downto 8) <= i(1 downto 0);
			WHEN "00011010" =>
				o_13(7 downto 0) <= i;
			WHEN "00011011" =>
				o_13(9 downto 8) <= i(1 downto 0);
			WHEN "00011100" =>
				o_14(7 downto 0) <= i;
			WHEN "00011101" =>
				o_14(9 downto 8) <= i(1 downto 0);
			WHEN "00011110" =>
				o_15(7 downto 0) <= i;
			WHEN "00011111" =>
				o_15(9 downto 8) <= i(1 downto 0);
			WHEN "00100000" =>
				o_16(7 downto 0) <= i;
			WHEN "00100001" =>
				o_16(9 downto 8) <= i(1 downto 0);
			WHEN "00100010" =>
				o_17(7 downto 0) <= i;
			WHEN "00100011" =>
				o_17(9 downto 8) <= i(1 downto 0);
			WHEN "00100100" =>
				o_18(7 downto 0) <= i;
			WHEN "00100101" =>
				o_18(9 downto 8) <= i(1 downto 0);
			WHEN "00100110" =>
				o_19(7 downto 0) <= i;
			WHEN "00100111" =>
				o_19(9 downto 8) <= i(1 downto 0);
			WHEN "00101000" =>
				o_20(7 downto 0) <= i;
			WHEN "00101001" =>
				o_20(9 downto 8) <= i(1 downto 0);
			WHEN "00101010" =>
				o_21(7 downto 0) <= i;
			WHEN "00101011" =>
				o_21(9 downto 8) <= i(1 downto 0);
			WHEN "00101100" =>
				o_22(7 downto 0) <= i;
			WHEN "00101101" =>
				o_22(9 downto 8) <= i(1 downto 0);
			WHEN "00101110" =>
				o_23(7 downto 0) <= i;
			WHEN "00101111" =>
				o_23(9 downto 8) <= i(1 downto 0);
			WHEN "00110000" =>
				o_24(7 downto 0) <= i;
			WHEN "00110001" =>
				o_24(9 downto 8) <= i(1 downto 0);
			WHEN "00110010" =>
				o_25(7 downto 0) <= i;
			WHEN "00110011" =>
				o_25(9 downto 8) <= i(1 downto 0);
			WHEN "00110100" =>
				o_26(7 downto 0) <= i;
			WHEN "00110101" =>
				o_26(9 downto 8) <= i(1 downto 0);
			WHEN "00110110" =>
				o_27(7 downto 0) <= i;
			WHEN "00110111" =>
				o_27(9 downto 8) <= i(1 downto 0);
			WHEN "00111000" =>
				o_28(7 downto 0) <= i;
			WHEN "00111001" =>
				o_28(9 downto 8) <= i(1 downto 0);
			WHEN "00111010" =>
				o_29(7 downto 0) <= i;
			WHEN "00111011" =>
				o_29(9 downto 8) <= i(1 downto 0);
			WHEN "00111100" =>
				o_30(7 downto 0) <= i;
			WHEN "00111101" =>
				o_30(9 downto 8) <= i(1 downto 0);
			WHEN "00111110" =>
				o_31(7 downto 0) <= i;
			WHEN "00111111" =>
				o_31(9 downto 8) <= i(1 downto 0);
			WHEN "01000000" =>
				o_32(7 downto 0) <= i;
			WHEN "01000001" =>
				o_32(9 downto 8) <= i(1 downto 0);
			WHEN "01000010" =>
				o_33(7 downto 0) <= i;
			WHEN "01000011" =>
				o_33(9 downto 8) <= i(1 downto 0);
			WHEN "01000100" =>
				o_34(7 downto 0) <= i;
			WHEN "01000101" =>
				o_34(9 downto 8) <= i(1 downto 0);
			WHEN "01000110" =>
				o_35(7 downto 0) <= i;
			WHEN "01000111" =>
				o_35(9 downto 8) <= i(1 downto 0);
			WHEN "01001000" =>
				o_36(7 downto 0) <= i;
			WHEN "01001001" =>
				o_36(9 downto 8) <= i(1 downto 0);
			WHEN "01001010" =>
				o_37(7 downto 0) <= i;
			WHEN "01001011" =>
				o_37(9 downto 8) <= i(1 downto 0);
			WHEN "01001100" =>
				o_38(7 downto 0) <= i;
			WHEN "01001101" =>
				o_38(9 downto 8) <= i(1 downto 0);
			WHEN "01001110" =>
				o_39(7 downto 0) <= i;
			WHEN "01001111" =>
				o_39(9 downto 8) <= i(1 downto 0);
			WHEN "01010000" =>
				o_40(7 downto 0) <= i;
			WHEN "01010001" =>
				o_40(9 downto 8) <= i(1 downto 0);
			WHEN "01010010" =>
				o_41(7 downto 0) <= i;
			WHEN "01010011" =>
				o_41(9 downto 8) <= i(1 downto 0);
			WHEN "01010100" =>
				o_42(7 downto 0) <= i;
			WHEN "01010101" =>
				o_42(9 downto 8) <= i(1 downto 0);
			WHEN "01010110" =>
				o_43(7 downto 0) <= i;
			WHEN "01010111" =>
				o_43(9 downto 8) <= i(1 downto 0);
			WHEN "01011000" =>
				o_44(7 downto 0) <= i;
			WHEN "01011001" =>
				o_44(9 downto 8) <= i(1 downto 0);
			WHEN "01011010" =>
				o_45(7 downto 0) <= i;
			WHEN "01011011" =>
				o_45(9 downto 8) <= i(1 downto 0);
			WHEN "01011100" =>
				o_46(7 downto 0) <= i;
			WHEN "01011101" =>
				o_46(9 downto 8) <= i(1 downto 0);
			WHEN "01011110" =>
				o_47(7 downto 0) <= i;
			WHEN "01011111" =>	-- byte no. 96 == chan 48
				o_47(9 downto 8) <= i(1 downto 0);


			WHEN OTHERS =>
				NULL;

		END CASE;

		IF state = "01011111" THEN
			state <= "00000000";
			state_0 <= '1';
		ELSE
			state <= state + 1;
			state_0 <= '0';
		END IF;


	END PROCESS;
END a_reg_pwm_state;